<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1" indent="yes" version="4.0" omit-xml-declaration="yes"/>

<xsl:template match="map" mode="firstline">
  <xsl:param name="x" select="@x  + floor(- @p - number(concat('0',@px)))"/>
  <xsl:param name="last" select="1"/>
<xsl:if test="$last = 1 or (@x - $x) mod 2 != 0">
    <td ignore="true">
<xsl:if test="$last = 1 and (@x - $x) mod 2 != 0">
  <xsl:attribute name="rowspan">2</xsl:attribute>
</xsl:if>
    </td>
</xsl:if>
<xsl:if test="$x &lt; @x +floor(@p + number(concat('0',@px)))">
  <xsl:apply-templates select="." mode="firstline">
    <xsl:with-param name="x" select="$x + 1"/>
    <xsl:with-param name="last" select="$last"/>
  </xsl:apply-templates>
</xsl:if>
</xsl:template>

<xsl:template match="map" mode="middleline">
  <xsl:param name="x" select="@x"/>
  <xsl:param name="y" select="@y + floor(-@p - number(concat('0',@py)))"/>
  <xsl:variable name="line" select="4*$x + 2*$y - 3*@x"/>
    <!-- parse sur les x pair-->
  <tr>
    <td width="0" height="{@cellsize div 2}" ignore="true"/>
  <xsl:apply-templates select="." mode="cell">
    <xsl:with-param name="line" select="$line"/>
  </xsl:apply-templates>
  </tr>
    <!-- parse sur les x impair-->
<xsl:if test="$y &lt; @y + floor(@p + number(concat('0',@py)))">
  <tr>
    <td width="0" height="{@cellsize div 2}" ignore="true"/>
  <xsl:apply-templates select="." mode="cell">
    <xsl:with-param name="d" select="1"/>
    <xsl:with-param name="line" select="$line"/>
  </xsl:apply-templates>
  </tr>
   <!-- on recommence -->
  <xsl:apply-templates select="." mode="middleline">
    <xsl:with-param name="y" select="$y + 1"/>
  </xsl:apply-templates>
</xsl:if>
</xsl:template>

<xsl:template match="map" mode="cell">
  <xsl:param name="x" select="@x + floor(-@p - number(concat('0',@px)))"/>
  <xsl:param name="line"/>
  <xsl:param name="d" select="0"/>
  <xsl:variable name="y" select="($line - $x + $d) div 2 "/>
  <xsl:variable name="absdeltax">
    <xsl:choose>
      <xsl:when test="@x - $x &gt; 0"><xsl:value-of select="@x - $x"/></xsl:when>
      <xsl:otherwise><xsl:value-of select="$x - @x"/></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="absdeltay">
    <xsl:choose>
      <xsl:when test="@y - $y &gt; 0"><xsl:value-of select="@y - $y"/></xsl:when>
      <xsl:otherwise><xsl:value-of select="$y - @y"/></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
<xsl:if test="(@x + 2*@p - $x) mod 2 = $d">
    <td rowspan="2" height="{@cellsize}" width="{@cellsize}" ignore="true">
<!--    <xsl:if test="($absdeltay &lt;= @p and $absdeltax &lt;= @p)">
    <xsl:if test="(@y - $y) + (@x - $x) &lt;= @p and (@y - $y) + (@x - $x) &gt;= -@p">
  <xsl:attribute name="ignore">false</xsl:attribute>-->
  <xsl:apply-templates select="pt[@x=$x and @y=$y]"/>
      <xsl:if test="not(pt[@x=$x and @y=$y])">
  <xsl:apply-templates select="modele/pt">
    <xsl:with-param name="x" select="$x"/>
    <xsl:with-param name="y" select="$y"/>
  </xsl:apply-templates>
<!--      </xsl:if>
    </xsl:if>-->
  </xsl:if>
    </td>
</xsl:if>
<xsl:if test="$x &lt; @x + floor(@p + number(concat('0',@px)))">
  <xsl:apply-templates select="." mode="cell">
    <xsl:with-param name="x" select="$x + 1"/>
    <xsl:with-param name="d" select="$d"/>
    <xsl:with-param name="line" select="$line"/>
  </xsl:apply-templates>
</xsl:if>
</xsl:template>

<xsl:template match="map">
<table  width="{@cellsize * (@p * 2 +2)}">
  <xsl:copy-of select="modele/table/@*"/>
  <xsl:if test="@title">
    <tr>
      <th colspan="{2 * (floor(@p + number(concat('0',@px))) ) + 2}"><xsl:value-of select="@title"/></th>
    </tr>
  </xsl:if>
  <tr>
    <td height="0" width="0" ignore="true"/>
  <xsl:apply-templates select="." mode="firstline"/>
  </tr>
  <xsl:apply-templates select="." mode="middleline"/>
  <tr>
    <td width="0" height="{@cellsize div 2}"/>
  <xsl:apply-templates select="." mode="firstline">
    <xsl:with-param name="last" select="0"/>
  </xsl:apply-templates>
  </tr>
</table>
</xsl:template>

<xsl:template match="pt">
  <xsl:copy-of select="../modele/td/@*"/>
  <xsl:apply-templates select="@type|*|text()"/>
</xsl:template>

<xsl:template match="modele/pt" priority="1">
  <xsl:param name="x"/>
  <xsl:param name="y"/>
  <xsl:copy-of select="../modele/td/@*"/>
  <xsl:apply-templates select="@type|*|text()"/>
</xsl:template>

</xsl:stylesheet>